              $NODEBUG
              $GEN
;
;
;
;
;
;  iCARD v1.1  (c) 1995 DSH
;
;
;ͻ
; P 3.0  - RxD <-> V.24 CARD DATA    P 3.5 - T1 N.C.                  
; P 3.1  - TxD <-> V.24 CARD DATA                                     
; P 3.2  - INT0 <-> V.24             P 1.5 - SDA                      
; P 3.3  - INT1 <-> CARD RESET       P 1.6 - SCL                      
; P 3.4  - T0 SWITCH                 P 1.7 - SYNC                     
;ͼ
;
;
;
;
EEPROM        EQU 10101110B                 ; GERTEADRESSE EEPROM 24C65
;                                           ; BIT1-3 = A0-2 AM EEPROM
BASIS         EQU 0000H
RAMSTART      EQU 8000H
;
BUFFER        EQU RAMSTART + 1F00H          ; BYTEPUFFER 9F00-9F3F, 64 BYTES
;
ATRDELAY      EQU 3000H                     ; ANSWER-TO-RESET WARTEZEIT
V24DELAY      EQU 46H                       ; 'BYTE SENDEN' WARTEZEIT
MAXOSD        EQU 8                         ; LNGE DER OSD-MELDUNG
;
;
;
;             1 PORTZUWEISUNGEN
;             -----------------
;
SDA           BIT P1.5                      ; DATENLEITUNG IC
SCL           BIT P1.6                      ; TAKTLEITUNG IC
ENABLE        BIT P3.4                      ; SCHALTER
GLED          BIT P1.0                      ; LED, GRN
RLED          BIT P1.1                      ; LED, ROT
RXDATA        BIT P3.0                      ; RXD-PIN
TXDATA        BIT P3.1                      ; TXD-PIN
RST           BIT P3.3                      ; RESET-PIN
;
;
;
;             2 INTERNES BIT-ORIENTIERTES RAM
;             -------------------------------
;
BUSFAULT      BIT 00H                       ; "BUS FAULT" (IC)
I2CBUSY       BIT 01H                       ; "BUSY FLAG" (IC)
EEPROMFLAG    BIT 02H                       ; "EEPROM VORHANDEN"
INVERT        BIT 03H                       ; "INVERTIERT SENDEN/EMPFANGEN"
HOSTFLAG      BIT 04H                       ; "HOST DATENBERTRAGUNG"
NOACK         BIT 05H                       ; "KEIN ACK EMPFANGEN" (IC)
HASHFLAG      BIT 06H                       ; "HASH-ALGORITHMUS IM EXT. RAM"
DATAFLAG      BIT 07H                       ; "DATEN EINGELESEN"
CODEFLAG      BIT 08H                       ; "CODES GENERIEREN"
ANSWERFLAG    BIT 09H                       ; "CODES ERZEUGT"
SOFTFLAG      BIT 0AH                       ; "SOFT SCRAMBLED"
READYFLAG     BIT 0BH                       ; "HAUPTPROGRAMM IST BEREIT"
OSDFLAG       BIT 0CH                       ; "OSD DAUERHAFT ANZEIGEN"
;
;
;
;             3 INTERNES BYTE-ORIENTIERTES RAM
;             --------------------------------
;
ANSWER        DATA 10H                      ; PUFFER (-17, 8 BYTES)
EEPROM_MSB    DATA 18H                      ; EEPROM-ADRESSE MSB A8-A12
EEPROM_LSB    DATA 19H                      ; EEPROM-ADRESSE LSB A0-A7
COUNT         DATA 1AH                      ; ZHLER FR INSTRUCTION
PRECOUNT      DATA 1BH                      ; ZWISCHENSPEICHER FR ZHLER
INSCOUNT      DATA 1CH                      ; ANZAHL BYTES
BDELAY        DATA 1DH                      ; BYTEWAIT-ZEIT
INSBYTE       DATA 1EH                      ; INSTRUCTIONCODE
BYTE          DATA 1FH                      ; AKTUELLES BYTE
POINTER       DATA 23H                      ; ZEIGER IN PUFFER
OSDCOUNT      DATA 24H                      ; ZHLER FR OSD
XCOUNT        DATA 25H                      ; ZHLER FR EXTERNES RAM
KEYPNTLSB     DATA 26H                      ; ZEIGER IN CODETABELLE LSB
KEYPNTMSB     DATA 27H                      ; ZEIGER IN CODETABELLE MSB
CHANNELID     DATA 28H                      ; KANAL-IDENTIFIKATION
KEYINDEX      DATA 29H                      ; INDEX IN KEYTABELLE
OSDPNTLSB     DATA 2AH                      ; ZEIGER AUF OSD LSB
OSDPNTMSB     DATA 2BH                      ; ZEIGER AUF OSD MSB
;
CODES         DATA 40H                      ; KEYPUFFER (-5F, 32 BYTES)
;
;
;
;
              ORG  BASIS
;
              JMP  STARTUP
;
;
;
              ORG  BASIS+0003H              ; EXTERNER INTERRUPT 0
;
              JMP  DO_INT0
;
;
;
              ORG  BASIS+000BH              ; INTERUPT TIMER 0
;
              JMP  DO_T0INT
;
;
;
              ORG  BASIS+0013H              ; EXTERNER INTERRUPT 1
;
              JMP  DO_INT1
;
;
;
              ORG  BASIS+0023H              ; SERIELLE SCHNITTSTELLE
;
              JMP  DO_V24INT
;
;
;
TABLE:        JMP  GETCLA                   ; COUNT=00
              JMP  GETINS                   ; COUNT=01
              JMP  GETPX                    ; COUNT=02
              JMP  GETPX                    ; COUNT=03
              JMP  GETP3                    ; COUNT=04
;
              JMP  INS70                    ; COUNT=05
              JMP  INS72                    ; COUNT=06
              JMP  INS74                    ; COUNT=07
              JMP  INS76                    ; COUNT=08
              JMP  INS78                    ; COUNT=09
              JMP  INS7A                    ; COUNT=10
              JMP  INS7C                    ; COUNT=11
              JMP  INS7E                    ; COUNT=12
              JMP  INS80                    ; COUNT=13
              JMP  INS82                    ; COUNT=14
;
              JMP  STOREX                   ; COUNT=15
              JMP  STOREI                   ; COUNT=16
;
;
;
STARTUP:      CLR  EA                       ; VORSICHTSHALBER INTS SPERREN
              MOV  SP,#60H                  ; STACK VON 60-7F (32 BYTES)
              MOV  PSW,#0                   ; STATUS LSCHEN
              MOV  P1,#0FFH                 ; ALLE PORTBITS AUF "1"
              MOV  P3,#0FFH
              CALL INIT_SFR                 ; SPECIAL FUNCTION REGISTER INIT.
              CALL INIT_IRAM                ; INT. RAM LSCHEN
              SETB RLED
              SETB GLED                     ; LEDS AUS
              SETB EA                       ; INT EIN
              SETB READYFLAG                ; HAUPTPROGRAMM IST BEREIT
MAINLOOP:     JNB  ENABLE,DISABLE           ; SCHALTER AUF ENABLE ?
              JNB  CODEFLAG,MAINLOOP        ; KEY ERZEUGEN ?
              CLR  RLED                     ; ROTE LED EIN
              JNB  HASHFLAG,DOROMPROG       ; HASH-ALGO. IM ROM BENUTZEN ?
              CALL RAMSTART                 ; NEIN, DANN IM RAM AUSFHREN
              JMP  HASHEXIT                 ; UND ENDE
;
;
;
DOROMPROG:    MOV  DPL,KEYPNTLSB
              MOV  DPH,KEYPNTMSB
              MOV  A,KEYINDEX
              CALL ADD_ADRESS
              MOV  R0,#ANSWER
              MOV  R2,#8
              CALL ZERORAM
              MOV  R0,#CODES
              MOV  R1,#ANSWER
              MOV  R7,#27
INITHASH:     MOV  A,@R0
              CALL KERNEL                   ; HASH INITIALISIEREN
              INC  R0
              DJNZ R7,INITHASH
              MOV  R7,#4
              CLR  A
HASHMAIN:     MOV  R3,A
              CALL KERNEL
              MOV  A,R3
              CALL KERNEL                   ; HASH FORTFHREN
              INC  R1
              CJNE R1,#ANSWER+8,HASHLOOP
              MOV  R1,#ANSWER
HASHLOOP:     MOV  A,@R0
              INC  R0
              DJNZ R7,HASHMAIN
              MOV  A,@R0
              MOV  R3,A
              MOV  R7,#64
FINALOOP:     MOV  A,R3
              CALL KERNEL                   ; UND ZUM LETZTENMAL...
              DJNZ R7,FINALOOP
              MOV  A,ANSWER+7
              ANL  A,#0FH                   ; NUR 60 BIT !
              MOV  ANSWER+7,A
HASHEXIT:     SETB RLED                     ; ROTE LED AUS
              SETB ANSWERFLAG               ; FLAG SETZEN
              CLR  CODEFLAG                 ; FLAG LSCHEN
              JMP  MAINLOOP                 ; ENDE
;
;
;
DISABLE:      CLR  EA                       ; INTERRUPTS AUS
              SETB RLED
              SETB GLED                     ; LEDS AUS
              JNB  ENABLE,$                 ; WARTEN ....
              JMP  STARTUP                  ; DANN NEUSTART !
;
;
;
KERNEL:       MOV  B,A
              XRL  A,@R1
              MOV  @R1,A
              SWAP A
              ANL  A,#0FH                   ; KERNROUTINE DES
              MOVC A,@A+DPTR                ; HASH-ALGORITHMUS
              MOV  R2,A
              MOV  A,@R1
              ANL  A,#0FH
              ADD  A,#16
              MOVC A,@A+DPTR
              ADD  A,R2
              CPL  A
              RL   A
              ADD  A,B
              SWAP A
              RL   A
              INC  R1
              CJNE R1,#ANSWER+8,NOBEGIN
              MOV  R1,#ANSWER
NOBEGIN:      XRL  A,@R1
              MOV  @R1,A
              RET
;
;
;
INIT_IRAM:    MOV  R0,#1
              CLR  A                        ; INTERNES RAM VON 08-5F LSCHEN
FILL_RAM:     MOV  @R0,A
              INC  R0
              CJNE R0,#60H,FILL_RAM
              SETB INVERT                   ; BYTES INVERTIERT SENDEN/EMPFANGEN
              MOV  OSDPNTLSB,#LOW  OSD
              MOV  OSDPNTMSB,#HIGH OSD
              RET
;
;
;
COPY_ROM:     MOVX A,@DPTR                  ; BYTE LADEN
              MOV  @R0,A                    ; IN INT. RAM
              INC  R0                       ; ZIELZEIGER + 1
              INC  DPTR                     ; QUELLZEIGER + 1
              DJNZ R2,COPY_ROM              ; UND NCHSTES BYTE
              RET
;
;
;
COPY_XRAM:    MOV  A,@R0
              MOVX @DPTR,A
              INC  R0
              INC  DPTR
              DJNZ R2,COPY_XRAM
              RET
;
;
;
COPY_RAM:     MOV  A,@R0                    ; BYTE LADEN
              MOV  @R1,A                    ; BYTE SPEICHERN
              INC  R0
              INC  R1                       ; ZEIGER + 1
              DJNZ R2,COPY_RAM              ; UND NCHSTES BYTE
              RET
;
;
;
ZERORAM:      CLR  A
              MOV  @R0,A                    ; AB @R0 MIT 00 SCHREIBEN
              INC  R0
              DJNZ R2,ZERORAM
              RET
;
;
;
ZEROXRAM:     CLR  A
              MOVX @DPTR,A                  ; AB @DPTR MIT 00 SCHREIBEN
              INC  DPTR
              DJNZ R2,ZEROXRAM
              RET
;
;
;
INIT_SFR:     CLR  F0                       ; STATUS-FLAG LSCHEN
              CLR  TR0                      ; TIMER 0 DISABLE
              CLR  TR1                      ; TIMER 1 DISABLE
              CLR  IE1                      ; INT1 LSCHEN
              CLR  IE0                      ; INT0 LSCHEN
              SETB IT0                      ; INT0 NEGATIVE FLANKE
              SETB IT1                      ; INT1 NEGATIVE FLANKE
              MOV  PCON,#0                  ; NORMALE BAUDRATEN
              MOV  TMOD,#00100001B          ; T1=8-BIT AUTORELOAD, T0=16-BIT
              MOV  SCON,#11000000B          ; 9-BIT UART, T1=BAUDRATENGENERATOR
              MOV  TL1,#0FDH                ; 9600 BPS
              MOV  TH1,#0FDH
              SETB PX1                      ; INT1 HHERE PRIO
              CLR  TF1                      ; T1-FLAG LSCHEN
              CLR  TF0                      ; T0-FLAG LSCHEN
              SETB EX0                      ; INT0 ENABLE
              SETB EX1                      ; INT1 ENABLE
              SETB TR1                      ; T1 ENABLE
              CLR  ES                       ; SERIELLER INT DISABLE
              CLR  REN                      ; EMPFNGER DISABLE
              RET
;
;
;
ROTATE_ACC:   CLR  C                        ; C LSCHEN
              RRC  A                        ; BIT 0 IN CARRY
              MOV  B.7,C                    ; IN BIT 7 VON B
              RRC  A                        ; BIT 1 IN CARRY
              MOV  B.6,C                    ; IN BIT 6 VON B
              RRC  A                        ; BIT 2 IN CARRY
              MOV  B.5,C                    ; IN BIT 5 VON B
              RRC  A                        ; BIT 3 IN CARRY
              MOV  B.4,C                    ; IN BIT 4 VON B
              RRC  A                        ; BIT 4 IN CARRY
              MOV  B.3,C                    ; IN BIT 3 VON B
              RRC  A                        ; BIT 5 IN CARRY
              MOV  B.2,C                    ; IN BIT 2 VON B
              RRC  A                        ; BIT 6 IN CARRY
              MOV  B.1,C                    ; IN BIT 1 VON B
              RRC  A                        ; BIT 7 IN CARRY
              MOV  B.0,C                    ; IN BIT 0 VON B
              MOV  A,B                      ; ZURCK IN ACC
              CPL  A                        ; INVERTIEREN
              MOV  C,P                      ; PARITY
              MOV  TB8,C                    ; IN SENDEREGISTER
              CPL  TB8                      ; PARITY INVERTIEREN
              RET
;
;
;
ADD_ADRESS:   ADD  A,DPL
              MOV  DPL,A
              JNC  NO_HIGH                  ; DPTR = DPTR + A
              INC  DPH
NO_HIGH:      RET
;
;
;
SUB_ADRESS:   CLR  C
              MOV  B,A                      ; SICHERN
              MOV  A,DPL
              SUBB A,B                      ; LSB - A
              MOV  DPL,A
              MOV  A,DPH
              SUBB A,#0                     ; MSB - C
              MOV  DPH,A
              RET
;
;
;
CHECK_CNT:    MOV  A,R6                     ; LSB
              CLR  C
              SUBB A,#1                     ; - 1
              MOV  R6,A                     ; UND ZURCK
              MOV  A,R7                     ; MSB
              SUBB A,#0                     ; - 0 (-C)
              MOV  R7,A                     ; UND ZURCK
              RET
;
;
;
BITDLY:       NOP                           ; DELAY CA. 5S
              NOP
              RET
;
;
;
SCLHIGH:      SETB SCL                      ; SCL=1
WAIT_SCL:     MOV  R6,#0                    ; ZHLER MSB
              MOV  R7,#0                    ; ZHLER LSB
SCL_LOOP:     JB   SCL,EXIT_SCL             ; SCL = 1 ?, DANN ENDE
              DJNZ R7,SCL_LOOP              ; LSB - 1
              DJNZ R6,SCL_LOOP              ; MSB - 1
              SETB BUSFAULT                 ; FEHLERFLAG SETZEN
EXIT_SCL:     RET
;
;
;
SENDSTOP:     CLR  SDA                      ; SDA=0
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY
              SETB SDA                      ; SDA=1 (STOPSEQUENZ)
              CALL BITDLY
              CLR  I2CBUSY                  ; "BUSY"-STATUS LSCHEN
              RET
;
;
;
SENDBYTE:     MOV  R3,#8                    ; BITZHLER
SBLOOP:       RLC  A                        ; MSBIT IN CARRY
              MOV  SDA,C                    ; SDA=DATA
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY                   ; DELAY
              CLR  SCL                      ; SCL=0
              CALL BITDLY                   ; DELAY
              DJNZ R3,SBLOOP                ; NCHSTES BIT
              SETB SDA                      ; SDA=1 (FR ACK)
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY                   ; DELAY
              JNB  SDA,SBEX                 ; ACK ?, DANN WEITER
              SETB NOACK                    ; SONST FLAG SETZEN
SBEX:         CLR  SCL                      ; SCL=0
              CALL BITDLY                   ; DELAY
              RET
;
;
;
SENDACC:      SETB I2CBUSY                  ; BUS IST "BUSY"
              CLR  NOACK                    ; STATUS LSCHEN
              SETB BUSFAULT                 ; FEHLER SETZEN
              JNB  SCL,FAULT                ; SCL=1 ? NEIN, DANN FEHLER
              JNB  SDA,FAULT                ; SDA=1 ? NEIN, DANN FEHLER
              CLR  SDA                      ; SDA=0 (STARTSEQUENZ)
              CALL BITDLY                   ; DELAY
              CLR  SCL                      ; SCL=0
              CALL BITDLY                   ; DELAY
              CALL SENDBYTE                 ; ACC SENDEN
              CLR  BUSFAULT                 ; STATUS LSCHEN, ALLES OK.
FAULT:        RET
;
;
;
RCVBYTE:      MOV  R3,#8                    ; BITZHLER
RBLOOP:       CALL SCLHIGH                  ; SCL=1
              CALL BITDLY                   ; DELAY
              MOV  C,SDA                    ; C=DATA
              RLC  A                        ; IN ACC (MSB ZUERST)
              CLR  SCL                      ; SCL=0
              CALL BITDLY                   ; DELAY
              DJNZ R3,RBLOOP                ; NCHSTES BIT
              MOV  C,F0                     ; C=FLAG
              MOV  SDA,C                    ; UND C IN SDA
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY                   ; DELAY
              CLR  SCL                      ; SCL=0
              SETB SDA                      ; SDA=1
              CALL BITDLY                   ; DELAY
              RET
;
;
;
RCVDATA:      CLR  F0
              CALL INITREAD
              JB   NOACK,RDEX
              JB   BUSFAULT,RDEX
              SETB SCL                      ; SCL=1
              MOV  A,#EEPROM                ; GERTEADRESSE
              ORL  A,#00000001B             ; READ-BIT
              CALL SENDACC                  ; SENDEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              CJNE A,#0AAH,RDEX
              CALL SENDSTOP
              MOV  A,#EEPROM                ; GERTEADRESSE
              ORL  A,#00000001B             ; READ-BIT
              CALL SENDACC                  ; SENDEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              CJNE A,#55H,RDEX
              CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              JNZ  RDEX
              CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOV  R6,A
              CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOV  R7,A
              MOV  DPTR,#RAMSTART
              MOV  B,#0
READLOOP:     CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOVX @DPTR,A
              INC  DPTR
              ADD  A,B
              MOV  B,A
              CALL CHECK_CNT
              JNC  READLOOP
              SETB F0
              CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              XRL  A,B
              JNZ  RDEX
              SETB HASHFLAG
              SETB EEPROMFLAG
RDEX:         CALL SENDSTOP
              RET
;
;
;
INITREAD:     MOV  A,#EEPROM                ; GERTEADRESSE EEPROM 24C65
              ANL  A,#11111110B
              CALL SENDACC
              JB   NOACK,EXINIT             ; FEHLER ?
              JB   BUSFAULT,EXINIT
              MOV  A,EEPROM_MSB             ; ADRESS-MSB
              CALL SENDBYTE                 ; SENDEN
              JB   NOACK,EXINIT             ; FEHLER ?
              JB   BUSFAULT,EXINIT
              MOV  A,EEPROM_LSB             ; ADRESS-LSB
              CALL SENDBYTE                 ; SENDEN
              JB   NOACK,EXINIT             ; FEHLER ?
              JB   BUSFAULT,EXINIT
              SETB SCL
EXINIT:       RET
;
;
;
SENDV24:      CLR  ES                       ; INT AUS
              CLR  REN                      ; EMPFNGER AUS
              MOV  C,P                      ; PARITT INS CARRY
              MOV  TB8,C                    ; = 9. DATENBIT
              JNB  INVERT,SENDIT            ; INVERTIEREN ?
              CALL ROTATE_ACC               ; JA, DANN ACCU ZURECHTDRSELN
SENDIT:       MOV  SBUF,A                   ; ACC IN SENDEREGISTER
              JNB  TI,$                     ; FERTIG ?
              CLR  TI                       ; FLAG LSCHEN
              MOV  A,#V24DELAY              ; WARTEZEIT
              CALL DELAY                    ; UND WARTEN !
              CLR  RI                       ; FLAG LSCHEN
              SETB REN                      ; EMPFNGER EIN
              SETB ES                       ; INT EIN
              RET
;
;
;
DELAY:        JZ   EXDELAY
              NOP                           ; WARTESCHLEIFE
              DEC  A
              JNZ  DELAY
EXDELAY:      RET
;
;
;
DO_INT0:      CLR  EA                       ; ALLE INTS AUS
              PUSH ACC
              PUSH B
              PUSH DPH
              PUSH DPL
              PUSH PSW
              MOV  PSW,#00001000B           ; REG.BANK 01
              SETB HOSTFLAG
              POP  PSW
              POP  DPL
              POP  DPH
              POP  B
              POP  ACC
              SETB EA                       ; ALLE INTS EIN
              RETI
;
;
;
DO_T0INT:     PUSH ACC
              PUSH B
              PUSH DPH
              PUSH DPL
              PUSH PSW
              MOV  PSW,#00001000B           ; REG.BANK 01
              CLR  TR0                      ; TIMER 0 STOPPPP !
              CLR  ET0                      ; TIMER 0-INT AUS
              MOV  DPTR,#ATR                ; ZEIGER AUF ANSWER-TO-RESET
              MOV  R0,#16                   ; 16 BYTES
SENDATR:      MOVX A,@DPTR
              CALL SENDV24                  ; BYTE AN DEKODER
              INC  DPTR
              DJNZ R0,SENDATR               ; UND NCHSTES BYTE
              SETB RLED                     ; ROTE LED AUS (WICHTIG !)
              CLR  IE1                      ; INT1-FLAG LSCHEN
              POP  PSW
              POP  DPL
              POP  DPH
              POP  B
              POP  ACC
              SETB EX1                      ; INT1 ENABLE
              RETI
;
;
;
DO_INT1:      PUSH ACC
              PUSH B
              PUSH DPH
              PUSH DPL
              PUSH PSW
              MOV  PSW,#00001000B           ; REG.BANK 01
              CLR  RLED                     ; ROTE LED EIN
              SETB GLED                     ; GRNE LED AUS
              CLR  ET0
              CLR  TR0                      ; WIE OBEN, T0 STOPPP
              MOV  TL0,#LOW  ATRDELAY       ; LSB
              MOV  TH0,#HIGH ATRDELAY       ; BERLAUFRATE MSB
              SETB ET0                      ; T0-INT ENABLE
              SETB TR0                      ; TIMER 0 START !
              CLR  EX1                      ; INT1 AUS
              SETB INVERT                   ; FLAG SETZEN
              SETB TXDATA
              CLR  DATAFLAG
              CLR  CODEFLAG
              CLR  ANSWERFLAG               ; FLAGS INIT
              CLR  SOFTFLAG
              CLR  A
              MOV  COUNT,A
              MOV  INSCOUNT,A
              MOV  OSDCOUNT,A
              POP  PSW
              POP  DPL
              POP  DPH
              POP  B
              POP  ACC
              RETI
;
;
;
DO_V24INT:    CLR  EX1
              PUSH ACC
              PUSH B
              PUSH DPH
              PUSH DPL
              PUSH PSW
              MOV  PSW,#00001000B           ; REG.BANK 01
              JNB  RI,EXITV24               ; BYTE EMPFANGEN ?
              CPL  GLED                     ; GRNE LED ....
              MOV  A,SBUF                   ; BYTE LADEN
              JNB  INVERT,GETIT             ; UMDREHEN ?
              CALL ROTATE_ACC               ; JA, DANN LOS
GETIT:        MOV  BYTE,A                   ; BYTE ERSTMAL SICHERN
EXECINS:      MOV  DPTR,#TABLE              ; SPRUNGTABELLE
              MOV  A,COUNT                  ; ZHLER LADEN
              MOV  B,A
              CLR  C
              RLC  A                        ; ZHLER * 2
              ADD  A,B                      ; + ZHLER (= ZHLER * 3)
              JMP  @A+DPTR                  ; UND AUSFHREN
;
;
;
HEADERFAULT:  MOV  COUNT,#0                 ; ZHLER WIEDER AUF NULL !
EXITV24:      CLR  RI                       ; FLAGS LSCHEN
              CLR  TI
              POP  PSW
              POP  DPL
              POP  DPH
              POP  B
              POP  ACC
              SETB EX1                      ; INT1 ENABLE
              RETI
;
;
;
GETCLA:       MOV  A,BYTE                   ; CLASSCODE (CLA)
              CJNE A,#53H,EXITV24           ; GLTIGER CLASSCODE ?
              INC  COUNT                    ; JAU, DANN ZHLER + 1 (=1)
              JMP  EXITV24
;
;
;
GETINS:       MOV  A,BYTE                   ; INSTRUCTIONCODE (INS)
              JB   ACC.0,HEADERFAULT        ; BIT 0 = 1, DANN FEHLER
              MOV  INSBYTE,A                ; SONST SICHERN
              INC  COUNT                    ; ZHLER + 1  (=2)
              JMP  EXITV24
;
;
;
GETPX:        MOV  A,BYTE                   ; P1 UND P2 WERDEN HIER
              JNZ  HEADERFAULT              ; BERPRFT (BEIDE = NULL)
              INC  COUNT                    ; ZHLER + 1 (=3 UND 4)
              JMP  EXITV24
;
;
;
GETP3:        MOV  A,BYTE                   ; ANZAHL BYTES
              MOV  INSCOUNT,A               ; ERSTMAL SICHERN
              MOV  B,INSBYTE
              MOV  R2,#10
              MOV  R4,#5
              MOV  DPTR,#INSTABLE
SEARCHINS:    MOVX A,@DPTR                  ; INS MIT TABELLE VERGLEICHEN
              XRL  A,B
              JZ   INSFOUND                 ; GEFUNDEN !!
              INC  DPTR
              INC  R4                       ; SONST WEITERSUCHEN
              DJNZ R2,SEARCHINS
              MOV  A,#90H                   ; SW1 = 90
              CALL SENDV24                  ; AN DEKODER
              MOV  A,#01H                   ; SW2 = 01
              CALL SENDV24                  ; AN DEKODER (FEHLER)
              JMP  HEADERFAULT              ; UND ENDE
;
;
;
INSFOUND:     MOV  A,R4                     ; INS-ZHLER
              MOV  COUNT,A                  ; SICHERN
              JMP  EXECINS                  ; UND INS AUSFHREN
;
;
;
SENDINS:      MOV  A,INSBYTE                ; INS
              CALL SENDV24                  ; AN DEKODER (ALLE WEITEREN BYTES
              RET                           ; KOMPLETTE BERTRAGEN)
;
;
;
SENDSWX:      MOV  A,#90H                   ; SW1 = 90
              CALL SENDV24                  ; AN DEKODER
              CLR  A                        ; SW2 = 00
              CALL SENDV24                  ; AN DEKODER (ALLES KLAR!)
              RET
;
;
;
SENDPUFFER:   MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT
PUFFERLOOP:   MOVX A,@DPTR                  ; PUFFERINHALT AN DEKODER SENDEN
              CALL SENDV24
              INC  DPTR
              DJNZ R2,PUFFERLOOP
              RET
;
;
;
SETCOUNT:     MOV  A,COUNT                  ; ZHLER ERSTMAL
              MOV  PRECOUNT,A               ; ZWISCHENSPEICHERN
              MOV  COUNT,#15                ; ZEIGER AUF "BYTES IN PUFFER LESEN"
              MOV  XCOUNT,#0                ; PUFFERINDEX SETZEN
              RET
;
;
;             INS = 70
;
;             KARTENINFORMATIONEN VON KARTE LESEN (6 BYTES)
;             DECODER <- KARTE
;
;
INS70:        CALL SENDINS                  ; INS AN DEKODER
              MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT
              CALL ZEROXRAM                 ; 6 NULLBYTES GENERIEREN
              CALL SENDPUFFER               ; PUFFER AN DEKODER
              CALL SENDSWX                  ; SW1 SW2 AN DEKODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 72
;
;             BYTES VON VORHERIGER KARTE SENDEN (16 BYTES)
;             DECODER -> KARTE
;
;
INS72:        JB   DATAFLAG,INS72DONE       ; ALLE 16 BYTES EINGELESEN ?
              CALL SENDINS                  ; INS AN DEKODER
              CALL SETCOUNT                 ; INIT.
              JMP  EXITV24                  ; ENDE
;
;
;
INS72DONE:    CLR  DATAFLAG                 ; FLAG LSCHEN
              CALL SENDSWX                  ; SW1 SW2 AN DEKODER
              MOV  COUNT,#0
              JMP  EXITV24                  ; ENDE
;
;
;             INS = 74
;
;             32 CODEBYTES AN KARTE
;             DECODER -> KARTE
;
;
INS74:        JB   DATAFLAG,INS74DONE       ; ALLE 32 BYTES GELESEN ?
              CALL SENDINS                  ; INS AN DECODER
              CALL SETCOUNT                 ; INIT.
              MOV  COUNT,#16                ; IN INTERNES RAM
              MOV  POINTER,#CODES           ; PUFFERZEIGER SETZEN
              JMP  EXITV24                  ; ENDE
;
;
;
INS74DONE:    CLR  DATAFLAG                 ; FLAG LSCHEN
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              CLR  SOFTFLAG                 ; FLAG INIT.
              MOV  A,CODES                  ; SCRAMBLEFLAG
              ANL  A,#0E0H                  ; HIGHNIBBLE = E ODER F ?
              XRL  A,#0C0H
              JNZ  HARDCRYPT                ; JAU, DANN VERSCHLSSELT
              SETB SOFTFLAG                 ; SONST "SOFTSCRAMBLED"
HARDCRYPT:    MOV  A,CODES                  ; SCRAMBLEFLAG
              JNB  ACC.3,ANSWERCODE         ; BIT 3 = 0, DANN ENDE
              JB   SOFTFLAG,ANSWERCODE      ; "SOFTSCRAMBLED" ?
              SETB CODEFLAG                 ; FLAG "KEY ERZEUGEN"
              MOV  KEYPNTLSB,#LOW  ADULT
              MOV  KEYPNTMSB,#HIGH ADULT
              MOV  KEYINDEX,#0
              CLR  ANSWERFLAG               ; FLAG INIT.
ANSWERCODE:   MOV  A,CODES+6                ; CHANNEL-ID LESEN
              ANL  A,#0FH                   ; BIT 0-3
              MOV  CHANNELID,A              ; TEXTINDEX SPEICHERN
              MOV  COUNT,#0
              JMP  EXITV24                  ; ENDE
;
;
;             INS = 76
;
;             AUTHORIZE-TASTER BETTIGT (1 BYTE)
;             DECODER -> KARTE
;
;
INS76:        JB   DATAFLAG,INS76DONE       ; BYTE GELESEN ?
              CALL SENDINS                  ; INS AN DECODER
              CALL SETCOUNT                 ; INIT.
              JMP  EXITV24
;
;
;
INS76DONE:    CLR  DATAFLAG                 ; FLAG LSCHEN
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 78
;
;             8 ANTWORTBYTES LESEN
;             DECODER <- KARTE
;
;
INS78:        JNB  READYFLAG,NOTREADY       ; HAUPTPROGRAMM SOWEIT ?
              JB   ANSWERFLAG,GOTIT         ; KEY ERZEUGT ?
NOTREADY:     CALL SENDINS                  ; INS AN DEKODER
              MOV  DPTR,#BUFFER
              MOV  R2,#8                    ; 8 NULLBYTES
              CALL ZEROXRAM
              CALL SENDPUFFER               ; AN DEKODER
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;
GOTIT:        CALL SENDINS                  ; INS SENDEN
              CLR  ANSWERFLAG               ; FLAGS LSCHEN
              MOV  R0,#ANSWER               ; QUELLZEIGER
              MOV  DPTR,#BUFFER             ; ZIELZEIGER
              MOV  R2,#8                    ; 8 BYTES
              CALL COPY_XRAM                ; KOPIEREN
              MOV  INSCOUNT,#8
              CALL SENDPUFFER               ; ANSWER AN DEKODER
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 7A
;
;             AUF DEM BILDSCHIRM AUZUGEBENDEN TEXT VON KARTE LESEN (25 BYTES)
;             DECODER <- KARTE
;
;
INS7A:        CALL SENDINS                  ; INS AN DECODER
              MOV  DPL,OSDPNTLSB
              MOV  DPH,OSDPNTMSB
              MOV  R0,#CODES
              MOV  R2,#25
              CALL COPY_ROM
              JB   OSDFLAG,DISPOSD
              MOV  CODES,#80H
              MOV  A,OSDCOUNT
              XRL  A,#MAXOSD
              JZ   DISPLAY
              INC  OSDCOUNT
DISPOSD:      MOV  CODES,#0D8H
DISPLAY:      MOV  DPTR,#BUFFER
              MOV  R0,#CODES
              MOV  R2,#25
              CALL COPY_XRAM
              CALL SENDPUFFER               ; STRING AN DECODER
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 7C
;
;             MESSAGE AN NCHSTE KARTE (16 BYTES)
;             DECODER <- KARTE
;
;
INS7C:        CALL SENDINS                  ; INS AN DECODER
              MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT              ; 16 NULLBYTES IN SENDEPUFFER
              CALL ZEROXRAM
              CALL SENDPUFFER               ; AN DECODER
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 7E
;
;             FIAT-SHAMIR-TEST (64 BYTES)
;             DECODER <- KARTE
;
;
INS7E:        CALL SENDINS                  ; INS AN DECODER
              MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT              ; 64 NULLBYTES
              CALL ZEROXRAM
              CALL SENDPUFFER               ; AN DECODER
              CALL SENDSWX
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 80
;
;             FIAT-SHAMIR-TEST (1 BYTE)
;             DECODER -> KARTE
;
;
INS80:        JB   DATAFLAG,INS80DONE       ; BYTE GELESEN ?
              CALL SENDINS                  ; N, DANN INS AN DECODER
              CALL SETCOUNT                 ; INIT.
              JMP  EXITV24
;
;
;
INS80DONE:    CLR  DATAFLAG                 ; FLAG LSCHEN
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 82
;
;             FIAT-SHAMIR-TEST (64 BYTES)
;             DECODER <- KARTE
;
;
INS82:        CALL SENDINS                  ; INS AN DECODER
              MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT              ; 64 NULLBYTES
              CALL ZEROXRAM
              CALL SENDPUFFER               ; AN DECODER SENDEN
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
NEXTBYTE:     JMP  EXITV24
;
;
;
STOREX:       MOV  DPTR,#BUFFER
              MOV  A,XCOUNT                 ; BYTE IN PUFFER (XRAM)
              CALL ADD_ADRESS
              MOV  A,BYTE
              MOVX @DPTR,A
              INC  XCOUNT
              DJNZ INSCOUNT,NEXTBYTE        ; NOCHN BYTE ?
              JMP  LASTBYTE                 ; NEIN, DANN FLAG SETZEN
;
;
;
STOREI:       MOV  R0,POINTER               ; ZEIGER INTERNES RAM
              MOV  A,BYTE
              MOV  @R0,A                    ; BYTE IN PUFFER
              INC  POINTER                  ; ZEIGER + 1
              DJNZ INSCOUNT,NEXTBYTE        ; NOCHN BYTE ?
LASTBYTE:     SETB DATAFLAG                 ; NEIN, DANN FLAG SETZEN
              MOV  A,PRECOUNT               ; ALTEN ZHLER
              MOV  COUNT,A                  ; WIEDERHERSTELLEN
              JMP  EXECINS                  ; UND INS AUSFHREN
;
;
;
ATR           DB   03FH,0FAH,011H,025H,005H,000H,001H,0B0H
              DB   002H,03BH,036H,04DH,059H,002H,081H,080H
;
OSD           DB   0D8H
              DB   ' ICARD V1.1 '
              DB   ' (C)',39,'95 DSH '
;
INSTABLE      DB   70H
              DB   72H
              DB   74H
              DB   76H
              DB   78H
              DB   7AH
              DB   7CH
              DB   7EH
              DB   80H
              DB   82H
;
ADULT         DB 056H,0F2H,0B6H,04FH,0C9H,0BDH,02AH,0B3H
              DB 09DH,081H,05DH,0E0H,005H,0B5H,0B9H,026H
              DB 067H,03CH,065H,0A0H,0BAH,039H,0C7H,0AFH
              DB 033H,024H,047H,0A6H,020H,01EH,014H,06FH
;
;
;
              END
;
;
;
;
